DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Protected Member Functions | List of all members
DiGSDFLUT Class Reference

Class to compute and store the GSDF lookup table. More...

Inheritance diagram for DiGSDFLUT:

## Public Member Functions
| DiGSDFLUT (const unsigned long count, const Uint16 max, const Uint16 *ddl_tab, const double *val_tab, const unsigned long ddl_cnt, const double *gsdf_tab, const double *gsdf_spl, const unsigned int gsdf_cnt, const double jnd_min, const double jnd_max, const double lum_min, const double lum_max, const double amb, const double illum, const OFBool inverse=OFFalse, STD_NAMESPACE ostream *stream=NULL, const OFBool printMode=OFTrue)
| constructor More...
virtual | ~DiGSDFLUT ()
| destructor
Public Member Functions inherited from DiDisplayLUT
| DiDisplayLUT (const unsigned long count, const Uint16 max, const double amb, const double illum=0)
| constructor More...
virtual | ~DiDisplayLUT ()
| destructor
double | getAmbientLightValue () const
| get ambient light value More...
double | getIlluminationValue () const
| get illumination value More...
Public Member Functions inherited from DiBaseLUT
| DiBaseLUT (const Uint32 count=0, const Uint16 bits=0)
| constructor More...
virtual | ~DiBaseLUT ()
| destructor
Uint32 | getCount () const
| get number of LUT entries More...
Uint16 | getBits () const
| get number of bits per entry More...
Uint32 | getFirstEntry (const Uint32=0) const
| get index of first LUT entry. More...
Sint32 | getFirstEntry (const Sint32) const
| get index of first LUT entry. More...
Uint32 | getLastEntry (const Uint32=0) const
| get index of last LUT entry. More...
Sint32 | getLastEntry (const Sint32) const
| get index of last LUT entry. More...
Uint16 | getValue (const Uint16 pos) const
| get value of specified LUT entry More...
Uint16 | getValue (const Uint32 pos) const
| get value of specified LUT entry. More...
Uint16 | getValue (const Sint32 pos) const
| get value of specified LUT entry. More...
Uint16 | getFirstValue () const
| get value of first LUT entry. More...
Uint16 | getLastValue () const
| get value of last LUT entry. More...
const Uint16 * | getData () const
| get pointer to LUT data More...
Uint16 | getMinValue () const
| get minimum value of the LUT. More...
Uint16 | getMaxValue () const
| get maximum value of the LUT. More...
Uint32 | getAbsMaxRange () const
| get absolute value range of the LUT entries. More...
int | isValid () const
| check whether LUT is valid More...
const char * | getExplanation () const
| get LUT explanation string More...
virtual OFBool | operator== (const DiBaseLUT &lut)
| compares current LUT with specified LUT More...

## Protected Member Functions
int | createLUT (const Uint16 *ddl_tab, const double *val_tab, const unsigned long ddl_cnt, const double *gsdf_tab, const double *gsdf_spl, const unsigned int gsdf_cnt, const double jnd_min, const double jnd_max, const double lum_min, const double lum_max, const OFBool inverse=OFFalse, STD_NAMESPACE ostream *stream=NULL, const OFBool printMode=OFTrue)
| create lookup table More...
Protected Member Functions inherited from DiBaseLUT
| DiBaseLUT (Uint16 *buffer, const Uint32 count=0, const Uint16 bits=0)
| constructor More...
int | compare (const DiBaseLUT *lut)
| compares current LUT with specified LUT More...

## Additional Inherited Members
Protected Attributes inherited from DiBaseLUT
Uint32 | Count
| number of LUT entries
Uint16 | FirstEntry
| first input value mapped (FIV)
Uint16 | Bits
| number of bits per entry
Uint16 | MinValue
| minimum LUT value
Uint16 | MaxValue
| maximum LUT value
int | Valid
| status code, indicating whether LUT is valid
OFString | Explanation
| LUT explanation string.
const Uint16 * | Data
| pointer to lookup table data
Uint16 * | DataBuffer
| pointer to data buffer (will be deleted in the destructor)

## Detailed Description

Class to compute and store the GSDF lookup table.

## Constructor & Destructor Documentation

## ◆ DiGSDFLUT()

DiGSDFLUT::DiGSDFLUT | ( | const unsigned long | count,
|  | const Uint16 | max,
|  | const Uint16 * | ddl_tab,
|  | const double * | val_tab,
|  | const unsigned long | ddl_cnt,
|  | const double * | gsdf_tab,
|  | const double * | gsdf_spl,
|  | const unsigned int | gsdf_cnt,
|  | const double | jnd_min,
|  | const double | jnd_max,
|  | const double | lum_min,
|  | const double | lum_max,
|  | const double | amb,
|  | const double | illum,
|  | const OFBool | inverse = `OFFalse`,
|  | STD_NAMESPACE ostream * | stream = `NULL`,
|  | const OFBool | printMode = `OFTrue`
| ) |  |

constructor

Parameters

  count | number of values to be stored in the LUT
  max | maximum value to be stored in the LUT
  ddl_tab | array of DDL values
  val_tab | array of values
  ddl_cnt | number of DDL values
  gsdf_tab | array with Grayscale Standard Display Function
  gsdf_spl | array with helper function used for interpolation
  gsdf_cnt | number of values in GSDF array
  jnd_min | minimum JND index value
  jnd_max | maximum JND index value
  lum_min | minimum luminance value to be used (lower border)
  lum_max | maximum luminance value to be used (upper border)
  amb | (reflected) ambient light value
  illum | illumination value
  inverse | apply inverse transformation if OFTrue
  stream | output stream (used to write curve data to a file)
  printMode | write CC and PSC to stream if OFTrue

## Member Function Documentation

## ◆ createLUT()

int DiGSDFLUT::createLUT | ( | const Uint16 * | ddl_tab,
|  | const double * | val_tab,
|  | const unsigned long | ddl_cnt,
|  | const double * | gsdf_tab,
|  | const double * | gsdf_spl,
|  | const unsigned int | gsdf_cnt,
|  | const double | jnd_min,
|  | const double | jnd_max,
|  | const double | lum_min,
|  | const double | lum_max,
|  | const OFBool | inverse = `OFFalse`,
|  | STD_NAMESPACE ostream * | stream = `NULL`,
|  | const OFBool | printMode = `OFTrue`
| ) |  |
| protected

create lookup table

Parameters

  ddl_tab | array of DDL values
  val_tab | array of luminance values
  ddl_cnt | number of DDL values
  gsdf_tab | array with Grayscale Standard Display Function
  gsdf_spl | array with helper function used for interpolation
  gsdf_cnt | number of values in GSDF array
  jnd_min | minimum JND index value
  jnd_max | maximum JND index value
  lum_min | minimum luminance value to be used (lower border)
  lum_max | maximum luminance value to be used (upper border)
  inverse | apply inverse transformation if OFTrue
  stream | output stream (used to write curve data to a file)
  printMode | write CC and PSC to stream if OFTrue

Returns
  status, true if successful, false otherwise

The documentation for this class was generated from the following file:

- dcmimgle/include/dcmtk/dcmimgle/digsdlut.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1